require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.*"
import "android.graphics.Bitmap"
import "android.graphics.Rect"
import "android.net.Uri"
import "java.io.*"
import "android.graphics.BitmapFactory"
import "android.graphics.Matrix"
import "android.graphics.RectF"

p=Rect()
node.getBoundsInScreen(p)
local wjj = "/storage/emulated/0/DCIM/Screenshots/"
local wjm=os.date("%Y%m%d_%H%M%S")..".jpg"
os.execute("mkdir -p "..wjj)

function fdtx()
-- 创建布局
local layout = {
LinearLayout,
layout_width = "fill",
layout_height = "100%h",
{
ImageView,
id = "imageView",
layout_width = "fill",
layout_height = "100%h",
background="#ff000000",
scaleType = "matrix",
},
}
-- 加载布局
local id = {}
local view = loadlayout(layout, id)
local imageView = id.imageView
-- 加载图片
local bitmap
pcall(function()
bitmap = BitmapFactory.decodeFile(wjj..wjm)
end)
if not bitmap then
Toast.makeText(service, "图片加载失败", Toast.LENGTH_SHORT).show()
return
end
imageView.setImageBitmap(bitmap)
-- 初始化矩阵参数
local matrix = Matrix()
local savedMatrix = Matrix()
local currentScale = 1.0
local minScale = 1.0
local maxScale = 15.0
local lastX, lastY = 0, 0
local isDragging = false
-- 初始缩放设置
local function setupInitialScale()
local imgWidth = bitmap.getWidth()
local imgHeight = bitmap.getHeight()
local viewWidth = imageView.getWidth()
local viewHeight = imageView.getHeight()
if imgWidth > 0 and imgHeight > 0 then
local scale = math.min(viewWidth/imgWidth, viewHeight/imgHeight)
currentScale = scale * 3
matrix.setScale(currentScale, currentScale)
matrix.postTranslate(
(viewWidth - imgWidth * currentScale)/2,
(viewHeight - imgHeight * currentScale)/2
)
imageView.setImageMatrix(matrix)
end
end
-- 边界限制
local function limitTranslate()
local rect = RectF(0, 0, bitmap.getWidth(), bitmap.getHeight())
matrix.mapRect(rect)
local viewWidth = imageView.getWidth()
local viewHeight = imageView.getHeight()
if rect.width() < viewWidth then
local dx = (viewWidth - rect.width())/2 - rect.left
matrix.postTranslate(dx, 0)
end
if rect.height() < viewHeight then
local dy = (viewHeight - rect.height())/2 - rect.top
matrix.postTranslate(0, dy)
end
end
-- 缩放手势检测器
local scaleGestureDetector = ScaleGestureDetector(service, {
onScale = function(detector)
local scaleFactor = detector.getScaleFactor()
scaleFactor = math.max(0.8, math.min(scaleFactor, 1.2))
currentScale = currentScale * scaleFactor
currentScale = math.max(minScale, math.min(currentScale, maxScale))
local focusX = detector.getFocusX()
local focusY = detector.getFocusY()
matrix.postScale(scaleFactor, scaleFactor, focusX, focusY)
imageView.setImageMatrix(matrix)
return true
end,
onScaleBegin = function(detector)
savedMatrix.set(matrix)
return true
end,
onScaleEnd = function(detector)
limitTranslate()
imageView.setImageMatrix(matrix)
end
})
-- 触摸事件处理（仅处理拖动和缩放）
imageView.setOnTouchListener({
onTouch = function(v, event)
scaleGestureDetector.onTouchEvent(event)
local action = event.getAction()
local x = event.getX()
local y = event.getY()
if action == MotionEvent.ACTION_DOWN then
lastX = x
lastY = y
isDragging = true
savedMatrix.set(matrix)
elseif action == MotionEvent.ACTION_MOVE then
if isDragging and event.getPointerCount() == 1 then
local dx = x - lastX
local dy = y - lastY
matrix.postTranslate(dx, dy)
imageView.setImageMatrix(matrix)
lastX = x
lastY = y
end
elseif action == MotionEvent.ACTION_UP or action == MotionEvent.ACTION_CANCEL then
isDragging = false
limitTranslate()
imageView.setImageMatrix(matrix)
end
return true
end
})
-- 初始缩放适配
imageView.post(function()
setupInitialScale()
end)
-- 创建对话框
local dlg = LuaDialog(service)
dlg.setView(view)
dlg.setCanceledOnTouchOutside(true)
dlg.setOnDismissListener({
onDismiss = function()
pcall(function() os.remove(wjj..wjm) end)
end
})
dlg.show()
end

function jt(n)
service.setTouchExplorationMode(false)
task(1000,function()
local fun={
onScreenCaptureDone = function(A0_4)
os.execute("mkdir ".."/storage/emulated/0/DCIM/Screenshots")
A0_4.compress(Bitmap.CompressFormat.PNG, 100, FileOutputStream(File(wjj,wjm)))
local intent = Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE)
intent.setData(Uri.fromFile(File(wjj..wjm)))
this.sendBroadcast(intent)
end}
if n then
this.getScreenShot(n,fun)
else
this.getScreenShot(fun)
end
service.setTouchExplorationMode(true)
end)
end

function tjsy()
edit=loadlayout({LinearLayout,orientation=1,{EditText,id="synr",hint="输入水印内容",layout_width=-1},
{EditText,id="ztdx",hint="字体大小",text="20",InputType="phone",layout_width=-1},
{EditText,id="ztys",hint="字体颜色",text="#ffff0000",layout_width=-1},
{EditText,id="sywz",hint="水印位置",text="bottom|right",layout_width=-1},
{LinearLayout,orientation=0,
{Button,text="红色",onClick=function()
ztys.text="#ffff0000"
end,
layout_width="14%w",background="#ffff0000",},
{Button,text="黄色",onClick=function()
ztys.text="#ffffff00"
end,
layout_width="14%w",background="#ffffff00",},
{Button,text="蓝色",onClick=function()
ztys.text="#ff0000ff"
end,
layout_width="14%w",background="#ff0000ff",},
{Button,text="绿色",onClick=function()
ztys.text="#ff00ff00"
end,
layout_width="14%w",background="#ff00ff00",},
{Button,text="白色",onClick=function()
ztys.text="#ffffffff"
end,
layout_width="14%w",background="#ffffffff",},
{Button,text="浅蓝色",onClick=function()
ztys.text="#ff00ffff"
end,
layout_width="14%w",background="#ff00ffff",},
{Button,text="浅红色",onClick=function()
ztys.text="#ffff00ff"
end,
layout_width="14%w",background="#ffff00ff",}},
{LinearLayout,orientation=0,
{Button,text="左上角",onClick=function()
sywz.text="top|left"
end,
layout_width="33%w",},
{Button,text="顶部居中",onClick=function()
sywz.text="top|center"
end,
layout_width="33%w",},
{Button,text="右上角",onClick=function()
sywz.text="top|right"
end,
layout_width="33%w"},},
{LinearLayout,orientation=0,
{Button,text="中部靠左",onClick=function()
sywz.text="center|left"
end,
layout_width="33%w",},
{Button,text="正中间",onClick=function()
sywz.text="center|center"
end,
layout_width="33%w",},
{Button,text="中部靠右",onClick=function()
sywz.text="center|right"
end,
layout_width="33%w",},},
{LinearLayout,orientation=0,
{Button,text="左下角",onClick=function()
sywz.text="bottom|left"
end,
layout_width="33%w",},
{Button,text="底部居中",onClick=function()
sywz.text="bottom|center"
end,
layout_width="33%w",},
{Button,text="右下角",onClick=function()
sywz.text="bottom|right"
end,
layout_width="33%w",}}
})
local syjm=LuaDialog()
syjm.setTitle("添加")
syjm.setView(edit)
syjm.setButton("添加",function()
local layout={FrameLayout,
background="#ff000000",
{
ImageView,
src=wjj..wjm,
layout_width = "wrap",
layout_height = "fill",
scaleType = "fitCenter",
},
{TextView,
text=synr.text,
contentDescription = "再次启动插件选择焦点截图保存",
Gravity=sywz.text,
textSize=ztdx.text.."sp",
textColor=ztys.text,
layout_width = "fill",
layout_height = "fill",
},
}
dlg=LuaDialog()
dlg.setView(loadlayout(layout))
dlg.show()
end)
syjm.setButton2("取消",function()
showMainDialog()
end)
task(1000,function()
syjm.show()
end)
end

function txsb(n,app)
service.setTouchExplorationMode(false)
task(1000,function()
local packageManager = service.getPackageManager()
local intent = packageManager.getLaunchIntentForPackage(app)

if intent == nil then
Toast.makeText(service, "在本设备未查找到相关应用", Toast.LENGTH_SHORT).show()
service.setTouchExplorationMode(true)
showMainDialog()
return
end

local fun={
onScreenCaptureDone = function(A0_4)
A0_4.compress(Bitmap.CompressFormat.PNG, 100, FileOutputStream(File("/sdcard/", "master_kaushik.jpg")))
this.startActivity(Intent(Intent.ACTION_SEND).setType("image/*").setPackage(app).putExtra(Intent.EXTRA_STREAM, this.getUriForFile(File("/sdcard/master_kaushik.jpg"))))
end}
if n then
this.getScreenShot(n,fun)
else
this.getScreenShot(fun) 
end
service.setTouchExplorationMode(true)
end)
task(15000,function()
os.remove("/storage/emulated/0/master_kaushik.jpg")
end)
end

function showMainDialog()
local layout={
LinearLayout,
orientation="horizontal",
layout_width=-1,
{ ListView,
id="list",
layout_width="50%w",
layout_height=-1,
},
{ ListView,
id="list2",
layout_width="50%w",
layout_height=-1,
},
}
local cj,cj2={"Be my eyes焦点识别","Be my eyes全屏识别","Lookout焦点识别","Lookout全屏识别","PiccyBot焦点识别","PiccyBot全屏识别","白描焦点识别","白描全屏识别","落寞工具箱焦点识别","落寞工具箱全屏识别","豆包焦点识别","豆包全屏识别","kimi焦点识别","kimi全屏识别","蓝心小V焦点识别","蓝心小V全屏识别"},{"焦点截图","焦点截图分享","全屏截图","全屏截图分享","焦点截图加水印","全屏截图加水印","区域截图","区域截图分享","焦点放大","全屏放大"}
jtgj=LuaDialog(this)
jtgj.setView(loadlayout(layout))
jtgj.setTitle("截图编辑识别工具")
jtgj.setButton3("说明",function()
local explainDialog = LuaDialog(this)
explainDialog.setTitle("使用说明")
explainDialog.setMessage([[左半部分包含了几个第三方的识别接口，包括Be my eyes、Lookout、PiccyBot、白描、落寞工具箱、豆包、kimi、蓝心小V，可以选择焦点或者全屏识别。
右半部截图功能、截图后加水印、截图分享，屏幕放大，每个功能都有焦点和全屏选项。
水印的文字可以自定义颜色、大小、途中的位置，包括左上角、顶部居中、右上角、中部靠左、中部居中、中部靠右、左下角、底部居中、右下角。
区域截图用法：找到你想截图的地方作为一个开始点，在屏幕任意位置启动插件，点击区域截图，然后找到你想截图的结束地方，再次启动插件完成截图。这个是通过焦点来定位的。如果本来就是图片，需要虚拟屏幕协助定位。
温馨提示：需要通过虚拟屏幕定位的，要把虚拟屏幕使用黑色背景这个关闭。
焦点放大和全屏放大，需要放大查看焦点所在的位置或整个屏幕放大查看，点击后默认放大三倍，可以通过双指捏合放大缩小。
作者：心灵亮光，QQ交流群：56793664。]])
explainDialog.setButton("返回", function()
explainDialog.dismiss()
showMainDialog()
end)
explainDialog.show()
end)
jtgj.setButton("取消",function()
jtgj.dismiss()
end)
list.adapter=SingleLineAdapter(service,String(cj))
list2.adapter=SingleLineAdapter(service,String(cj2))

list.onItemClick = function(l, v, p, i)
jtgj.dismiss()
if i==0 then
txsb(node,"com.bemyeyes.bemyeyes")
elseif i==1 then
txsb(_,"com.bemyeyes.bemyeyes")
elseif i==2 then
txsb(node,"com.google.android.apps.accessibility.reveal")
elseif i==3 then
txsb(_,"com.google.android.apps.accessibility.reveal")
elseif i==4 then
txsb(node,"com.sparklingapps.piccybot")
elseif i==5 then
txsb(_,"com.sparklingapps.piccybot")
elseif i==6 then
txsb(node,"com.uzero.baimiao")
elseif i==7 then
txsb(_,"com.uzero.baimiao")
elseif i==8 then
txsb(node,"com.lmdbk.tool")
elseif i==9 then
txsb(_,"com.lmdbk.tool")
elseif i==10 then
txsb(node,"com.larus.nova")
elseif i==11 then
txsb(_,"com.larus.nova")
elseif i==12 then
txsb(node,"com.moonshot.kimichat")
elseif i==13 then
txsb(_,"com.moonshot.kimichat")
elseif i==14 then
txsb(node,"com.vivo.ai.copilot")
elseif i==15 then
txsb(_,"com.vivo.ai.copilot")
end
end

list2.onItemClick = function(l, v, p, i)
local p=Rect()
node.getBoundsInScreen(p)
jtgj.dismiss()
if i==0 then
jt(node)
elseif i==1 then
jt(node)
task(1000,function()
service.shareFile(wjj..wjm)
end)
elseif i==2 then
jt(_)
elseif i==3 then
jt(_)
task(1000,function()
service.shareFile(wjj..wjm)
end)
elseif i==4 then
jt(node)
tjsy()
elseif i==5 then
jt(_)
tjsy()
elseif i==6 and qyjt==nil then
left = p.left
top =p.top
right =p.right
bottom =p.bottom
qyjt=true
service.asyncSpeak("选择开始点")
elseif i==7 and qyjt==nil then
left = p.left
top =p.top
right =p.right
bottom =p.bottom
qyjt=true
qyjtfx=true
service.asyncSpeak("选择开始点")
elseif i==8 then
jt(node)
task(1200, fdtx)
elseif i==9 then
jt(_)
task(1200, fdtx)
end
end
jtgj.show()
end

if qyjt==true then
left2=p.left
right2 =p.right
top2 =p.top
bottom2 =p.bottom
service.setTouchMode(false)
if left>=left2 then
left=left2
end
if right>=right2 then
right2=right
end
if top>bottom2 then
bottom2,top=bottom,top2
end
task(500,function()
this.getScreenShot({
onScreenCaptureDone = function(fullScreenBitmap)
-- 创建指定范围的矩形
local cropRect = Rect(left, top, right2, bottom2)

-- 从全屏截图中裁剪指定区域
local croppedBitmap = Bitmap.createBitmap(
fullScreenBitmap, 
cropRect.left, 
cropRect.top, 
cropRect.width(), 
cropRect.height()
)

-- 保存图片
local outStream = FileOutputStream(File(wjj, wjm))
croppedBitmap.compress(Bitmap.CompressFormat.JPEG, 100, outStream)
outStream.close()

-- 通知媒体库更新
local intent = Intent(Intent.ACTION_MEDIA_SCANNER_SCAN_FILE)
intent.setData(Uri.fromFile(File(wjj..wjm)))
this.sendBroadcast(intent)

-- 释放资源
croppedBitmap.recycle()
fullScreenBitmap.recycle()
end
})
qyjt=nil
service.asyncSpeak("截图完成")
service.setTouchMode(true)
end)
if qyjtfx==true then
task(500,function()
service.shareFile(wjj..wjm)
qyjtfx=nil
end)
end
else
showMainDialog()
end
return true